%define base_name qcg-comp
%define _sourcedir %{_topdir}/SOURCES/%{base_name}

%{!?default_package_ext: %define default_package_ext tar.gz}
%{!?system_name: %define system_name 0}

%global __os_install_post %{nil}


Summary:	QCG-Computing service
Summary(pl.UTF-8): Usluga QCG-Computing
Name:		%{base_name}
Version:	4.2.0
#Release:	15
Release:	19
License:	GPLv3 with exceptions
Group:		Applications/System
Source0:	%{name}-%{version}.%{default_package_ext}
Source1:	qcg-compd.init
Source2:	qcg-coordinatord.init
Source3:	qcg-compd.sysconfig
Source4:	qcg-compd.logrotate
Source5:	qcg-offer
Source6:	qcg-compd.service
Source7:	qcg-slurm-redis-notifier.service
Source8:	qcg-slurm-redis-notifier.init
URL:		http://www.qoscosgrid.org/trac/qcg-computing
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libtool
BuildRequires:	python-devel >= 2.4.0
BuildRequires:	qcg-core-devel >= 4.0.0

%if %{system_name} == "centos7"
BuildRequires: systemd
%endif

BuildRoot:	%{_tmppath}/%{name}-%{version}-root-%(id -u -n)
%if %{system_name} == "sl5"
Requires:	python-elementtree
%else
Requires:	python-lxml
%endif
Requires:	/usr/sbin/useradd /sbin/chkconfig
Requires:	libxml2-python
Requires:	postgresql-odbc >= 08.01.0200-3.1
Requires:	qcg-core >= 4.0.0
Requires:	qcg-comp-schemas

%define         _qcgdir        %{_prefix}

%ifarch x86_64
	%define         _libdir         %{_qcgdir}/lib64
%endif

%define         _depdir         /opt/qcg/dependencies
%define         _logrotatedir   %{_sysconfdir}/logrotate.d
%define		_qcgsysconfdir	%{_sysconfdir}/qcg/qcg-comp

# for generating debug symbols packages
	
%description
QCG Comp service.

%description -l pl.UTF-8
Serwis QCG Comp.

%package devel
Summary:	Header files for QCG-Computing modules
Summary(pl.UTF-8):	Pliki nagłówkowe mdułów QCG-Computing
Group:		Development/System
Requires:        %{name} = %{version}-%{release}

%description devel
Header files for qcg-comp modules.

%description devel -l pl.UTF-8
Pliki nagłówkowe modułów qcg-comp.

%package logrotate
Summary: 	The logrotate configuration for QCG-Computing service
Summary(pl.UTF-8):	Konfiguracja logrotate dla usługi QCG-Computing
Group:		Applications/System
Requires: 	%{name} = %{version}-%{release}

%description logrotate
The logroate configuration for QCG-Computing service.

%description logrotate -l pl.UTF-8
Konfiguracja logrotate dla usługi QCG-Computing

%package client
Summary: 	The QCG-Computing client
Summary(pl.UTF-8):	Klient usługi QCG-Computing
Group:		Applications/System
Requires:       qcg-core >= 2.4.0-3
Requires:	qcg-comp-schemas = %{version}-%{release}
Requires: 	globus-proxy-utils

%description client
The QCG-Computing client.

%description client -l pl.UTF-8
Klient usługi QCG-Computing.

%package coordinator
Summary:        The QCG-Coordinator service
Summary(pl.UTF-8):     Usługa QCG-Coordinator
Group:		Applications/System
Requires:       qcg-core >= 2.4.0-3
Requires:	qcg-comp-schemas = %{version}-%{release}

%description coordinator
The QCG-Coordinator service.

%description coordinator -l pl.UTF-8
Usługa QCG-Coordinator.

%package schemas
Summary:        The QCG-Computing schemas
Summary(pl.UTF-8):     Schemy uslugi QCG-Computing
Group:		Applications/System

%description schemas
The QCG-Computing schemas.

%description schemas -l pl.UTF-8
Schemy uslugi QCG-Computing.

%package java-sdk
Summary:        The QCG-Computing Java SDK
Summary(pl.UTF-8):     SDK QCG-Computing dla jezyka Java
Group:		Applications/System

%description java-sdk
The QCG-Computing Java SDK.

%description java-sdk -l pl.UTF-8
SDK QCG-Computing dla jezyka Java.

%package offer
Summary:        QCG-Offer command
Summary(pl.UTF-8):     QCG-Offer command
Group:		Applications/System

%description offer
QCG-Offer tool.

%description offer -l pl.UTF-8
Narzedzie QCG-Offer.

%package slurm-redis-notifier
Summary: 	Script for notifing about slurm job state changes
Summary(pl.UTF-8):	Skrypt do śledzenia zmian stanu zadań w Slurmie
Group:		Applications/System
Requires: 	python-redis

%description slurm-redis-notifier
Script for notifing about slurm job state changes

%description logrotate -l pl.UTF-8
Skrypt do śledzenia zmian stanu zadań w Slurmie


%prep
%setup -q

%build
%{!?configure_options: %define configure_options %{nil}} 

rm -f m4/libtool.m4 m4/ltoptions.m4 m4/ltsugar.m4 m4/ltversion.m4 m4/lt~obsolete.m4

%{__libtoolize} --copy --force
%{__aclocal} -I m4
%{__autoconf}
%{__autoheader}
%{__automake} -a -c -f --foreign
%configure \
	--sysconfdir=%{_qcgsysconfdir} \
        --with-qcg-core=%{_qcgdir} \
        --without-libcurl \
	%{configure_options} 
	
NUMCPU=`grep processor /proc/cpuinfo | wc -l`
[ $NUMCPU -eq 0 ] && NUMCPU=1;

make -j$NUMCPU

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT


%if %{system_name} == "centos7"
install -d $RPM_BUILD_ROOT/%{_unitdir}
%endif

# required by non-ported scripts such as qcg-coordinatord
install -d $RPM_BUILD_ROOT/%{_initrddir}

%if %{system_name} == "centos7"
install %{SOURCE6} $RPM_BUILD_ROOT/%{_unitdir}/qcg-compd.service
install %{SOURCE7} $RPM_BUILD_ROOT/%{_unitdir}/qcg-slurm-redis-notifier.service
%else
install %{SOURCE1} $RPM_BUILD_ROOT/%{_initrddir}/qcg-compd
install %{SOURCE7} $RPM_BUILD_ROOT/%{_initrddir}/qcg-slurm-redis-notifier
%endif
install %{SOURCE2} $RPM_BUILD_ROOT/%{_initrddir}/qcg-coordinatord
install -d $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig
install %{SOURCE3} $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig/qcg-compd
install -d $RPM_BUILD_ROOT/%{_localstatedir}/log/qcg/qcg-comp
install -d $RPM_BUILD_ROOT/%{_localstatedir}/run/qcg/qcg-comp
install -d $RPM_BUILD_ROOT/%{_localstatedir}/log/qcg/qcg-coordinator
install -d $RPM_BUILD_ROOT/%{_localstatedir}/run/qcg/qcg-coordinator

install -d $RPM_BUILD_ROOT/%{_logrotatedir}
install %{SOURCE4} $RPM_BUILD_ROOT/%{_logrotatedir}/qcg-comp

rm -f $RPM_BUILD_ROOT/%{_libdir}/qcg-comp/modules/*.la
rm -f $RPM_BUILD_ROOT/%{_libdir}/qcg-comp/modules/*.a
rm -f $RPM_BUILD_ROOT/%{_qcgsysconfdir}/*.dist

install -d $RPM_BUILD_ROOT/usr/share/qcg/qcg-comp-java-sdk/
install -d $RPM_BUILD_ROOT/usr/share/qcg/qcg-comp-java-sdk/endorsed
#very ugly hack
#install $HOME/tmp/qcg-comp/java/WSIT/QCGComputingSDK/target/QCGComputingSDK-3.4.0-jar-with-dependencies.jar $RPM_BUILD_ROOT/usr/share/qcg/qcg-comp-java-sdk/QCGComputingSDK.jar
install $HOME/tmp/qcg-comp/java/WSIT/QCGComputingSDK/target/QCGComputingSDK-4.0.0-jar-with-dependencies.jar $RPM_BUILD_ROOT/usr/share/qcg/qcg-comp-java-sdk/QCGComputingSDK.jar
install $HOME/tmp/qcg-comp/java/WSIT/QCGComputingSDK/lib/jaxws-api-2.2.9.jar $RPM_BUILD_ROOT/usr/share/qcg/qcg-comp-java-sdk/endorsed/jaxws-api-2.2.9.jar

install -d $RPM_BUILD_ROOT/%{_qcgsysconfdir}/offer
install %{SOURCE5} $RPM_BUILD_ROOT/%{_bindir}/qcg-offer
%pre

if ! getent group | grep  -q '^qcg-dev:' /etc/group; then
	/usr/sbin/groupadd -r qcg-dev >/dev/null 2>&1
fi

%if %{system_name} == "sl5"
	%define useradd_opts -M -n -r
%else
	%define useradd_opts -M -N -r
%endif

if ! id -u qcg-comp >/dev/null 2>&1; then
	/usr/sbin/useradd %{useradd_opts} -g qcg-dev -d /var/log/qcg/qcg-comp -s /bin/bash \
	    -c "QCG-Computing Service" qcg-comp >/dev/null 2>&1
fi

%pre coordinator

if ! getent group | grep  -q '^qcg-dev:' /etc/group; then
	/usr/sbin/groupadd -r qcg-dev >/dev/null 2>&1
fi

%if %{system_name} == "sl5"
	%define useradd_opts -M -n -r
%else
	%define useradd_opts -M -N -r
%endif

if ! id -u qcg-coord >/dev/null 2>&1; then
	/usr/sbin/useradd %{useradd_opts} -g qcg-dev -d /var/log/qcg/qcg-coordinator -s /bin/bash \
	    -c "QCG-Coordinator Service" qcg-coord >/dev/null 2>&1
fi


%post


touch %{_localstatedir}/log/qcg/qcg-comp/qcg-compd.log
chmod 750 %{_localstatedir}/log/qcg/qcg-comp/qcg-compd.log
chown qcg-comp:qcg-dev %{_localstatedir}/log/qcg/qcg-comp/qcg-compd.log

chown qcg-comp:qcg-dev %{_localstatedir}/log/qcg/qcg-comp/
chown qcg-comp:root    %{_localstatedir}/run/qcg/qcg-comp
chown qcg-comp:root    %{_qcgsysconfdir}/qcg-compd.xml
chown qcg-comp:qcg-dev %{_sysconfdir}/sysconfig/qcg-compd

%if %{system_name} != "centos7"
if [[ 0 -eq `/sbin/chkconfig --list qcg-compd 2>/dev/null | wc -l` ]] ; then
	/sbin/chkconfig --add qcg-compd
	echo 'Run "/sbin/service qcg-compd start" to start qcg-compd service.'
%else
/usr/bin/systemctl is-enabled qcg-compd 2>/dev/null
if [[ $? -ne 0 ]]; then
	/usr/bin/systemctl enable qcg-compd
	echo 'Run "systemctl start qcg-compd" to start qcg-compd service.'
%endif
	echo
	echo 'IMPORTANT: You must first configure the QCG Computing database prior to'
	echo 'starting the service. You can either use the' 
	echo %{_datadir}'/qcg-comp/tools/qcg-comp-install.sh script or'
	echo 'create it manually using the QCG Computing documentation available at '
	echo 'http://www.qoscosgrid.org/trac/qcg-computing/wiki/InstallingUsingRPMS as the reference.'
else
	echo "Restarting services..." 
%if %{system_name} != "centos7"
	if [ -f %{_localstatedir}/lock/subsys/qcg-compd ]; then
        	/sbin/service qcg-compd restart 1>&2 || :;
	fi
%else
	/usr/bin/systemctl is-active qcg-compd 2>/dev/null
	if [[ $? -eq 0 ]]; then
        	/usr/bin/systemctl restart qcg-compd 1>&2 || :;
	fi
%endif
fi


%post coordinator

touch %{_localstatedir}/log/qcg/qcg-coordinator/qcg-coordinatord.log
chown qcg-coord:qcg-dev %{_localstatedir}/log/qcg/qcg-coordinator/qcg-coordinatord.log
chmod 640 %{_localstatedir}/log/qcg/qcg-coordinator/qcg-coordinatord.log

chown qcg-coord:qcg-dev %{_localstatedir}/log/qcg/qcg-coordinator
chown qcg-coord:qcg-dev %{_localstatedir}/run/qcg/qcg-coordinator


if [[ 0 -eq `/sbin/chkconfig --list qcg-coordinatord 2>/dev/null | wc -l` ]] ; then

	/sbin/chkconfig --add qcg-coordinatord
        echo 'Run "/sbin/service qcg-coordinatord start" to start qcg-coordinatord service.'
        echo
else
	echo "Restarting services..." 
	if [ -f %{_localstatedir}/lock/subsys/qcg-coordinatord ]; then
        	/sbin/service qcg-coordinatord restart 1>&2 || :;
	fi
fi


%post slurm-redis-notifier

chown qcg-comp:root    %{_qcgsysconfdir}/qcg-slurm-redis-notifier.json
%if %{system_name} != "centos7"
if [[ 0 -eq `/sbin/chkconfig --list qcg-slurm-redis-notifier 2>/dev/null | wc -l` ]] ; then
	/sbin/chkconfig --add qcg-slurm-redis-notifier
	echo 'Run "/sbin/service qcg-slurm-redis-notifier start" to start qcg-slurm-redis-notifier service.'
%else
/usr/bin/systemctl is-enabled qcg-slurm-redis-notifier 2>/dev/null
if [[ $? -ne 0 ]]; then
	/usr/bin/systemctl enable qcg-slurm-redis-notifier
	echo 'Run "systemctl start qcg-slurm-redis-notifier" to start qcg-slurm-redis-notifier service.'
%endif
	echo
	echo 'IMPORTANT: You must first configure the QCG Slurm redis notifier prior to'
	echo 'starting the service. Plase edit file' 
	echo %{_qcgsysconfdir}'/qcg-comp/tools/qcg-comp-install.sh script or'
else
	echo "Restarting services..." 
%if %{system_name} != "centos7"
	if [ -f %{_localstatedir}/lock/subsys/qcg-slurm-redis-notifier ]; then
        	/sbin/service qcg-slurm-redis-notifier restart 1>&2 || :;
	fi
%else
	/usr/bin/systemctl is-active qcg-slurm-redis-notifier 2>/dev/null
	if [[ $? -eq 0 ]]; then
        	/usr/bin/systemctl restart qcg-slurm-redis-notifier 1>&2 || :;
	fi
%endif
fi

touch %{_localstatedir}/log/qcg/qcg-comp/qcg-slurm-redis-notifier.log
chmod 750 %{_localstatedir}/log/qcg/qcg-comp/qcg-slurm-redis-notifier.log
chown qcg-comp:qcg-dev %{_localstatedir}/log/qcg/qcg-comp/qcg-slurm-redis-notifier.log
chown qcg-comp:qcg-dev %{_localstatedir}/log/qcg/qcg-comp/


%preun
%if %{system_name} != "centos7"
if [ "$1" = "0" ]; then
        if [ -f %{_localstatedir}/lock/subsys/qcg-compd ]; then
                /sbin/service qcg-compd stop 1>&2 || :;
        fi
        /sbin/chkconfig --del qcg-compd

	rm %{_initrddir}/qcg-compd || :
fi
%else
if [ "$1" = "0" ]; then
	/usr/bin/systemctl is-active qcg-compd 2>/dev/null
	if [[ $? -eq 0 ]]; then
		/usr/bin/systemctl stop qcg-compd 1>&2 || :;
        fi
	/usr/bin/systemctl disable qcg-compd

	rm %{_unitdir}/qcg-compd.service || :
fi
%endif

%preun coordinator
if [ "$1" = "0" ]; then
        if [ -f %{_localstatedir}/lock/subsys/qcg-coordinatord ]; then
                /sbin/service qcg-coordinatord stop 1>&2 || :;
        fi
        /sbin/chkconfig --del qcg-coordinatord

	rm /etc/rc.d/init.d/qcg-coordinatord || :
fi

%preun slurm-redis-notifier
%if %{system_name} != "centos7"
if [ "$1" = "0" ]; then
        if [ -f %{_localstatedir}/lock/subsys/qcg-slurm-redis-notifier ]; then
                /sbin/service qcg-slurm-redis-notifier stop 1>&2 || :;
        fi
        /sbin/chkconfig --del qcg-slurm-redis-notifier

	rm %{_initrddir}/qcg-slurm-redis-notifier || :
fi
%else
if [ "$1" = "0" ]; then
	/usr/bin/systemctl is-active qcg-slurm-redis-notifier 2>/dev/null
	if [[ $? -eq 0 ]]; then
		/usr/bin/systemctl stop qcg-slurm-redis-notifier 1>&2 || :;
        fi
	/usr/bin/systemctl disable qcg-slurm-redis-notifier

	rm %{_unitdir}/qcg-slurm-redis-notifier.service || :
fi
%endif


%postun
#userdel -r qcg-comp >/dev/null 2>&1 || :
#groupdel qcg-comp >/dev/null 2>&1 || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/qcg-compd
%{_datadir}/qcg-comp/db
%doc %{_datadir}/qcg-comp/doc
%attr(755,root,root) %{_datadir}/qcg-comp/tools/qcg-comp-install.sh
%attr(755,root,root) %{_datadir}/qcg-comp/tools/setup-plgrid-plugin.sh
%dir %{_libdir}/qcg-comp
%dir %{_libdir}/qcg-comp/modules
%attr(644,root,root) %{_libdir}/qcg-comp/modules/application_mapper.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/atz_ardl_filter.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/atz_sandbox.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/lsf_jsdl_filter.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/notification_wsn.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/pbs_jsdl_filter.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/pbspro_jsdl_filter.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/qcg-comp-service.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/reservation_ares.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/reservation_python.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/sge_jsdl_filter.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/ll_jsdl_filter.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/slurm_jsdl_filter.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/eagle_queues.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/submission_drmaa.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/wd_sandboxing.so
%{_libdir}/qcg-comp/modules/python
%dir %attr(750,root,root) %{_localstatedir}/log/qcg/qcg-comp
%dir %attr(755,root,root) %{_localstatedir}/run/qcg/qcg-comp
%dir %{_qcgsysconfdir}
%config(noreplace) %attr(600,root,root) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-compd.xml
%config(noreplace) %attr(644,root,root) %verify(not md5 mtime size) %{_qcgsysconfdir}/application_mapfile
%config(noreplace) %attr(644,root,root) %verify(not md5 mtime size) %{_qcgsysconfdir}/nodes.conf
%config(noreplace) %attr(640,root,root) %verify(not md5 mtime size) %{_sysconfdir}/sysconfig/qcg-compd

%if %{system_name} == "centos7"
%attr(644,root,root) %{_unitdir}/qcg-compd.service
%else
%attr(755,root,root) %{_initrddir}/qcg-compd
%endif

%files devel
%defattr(644,root,root,755)
%{_includedir}/%{base_name}

%files logrotate
%defattr(644,root,root,755)
%config(noreplace)  %attr(644,root,root) %verify(not md5 mtime size) %{_logrotatedir}/qcg-comp

%files client
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/qcg-comp
%config(noreplace) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-comp.xml
%attr(644,root,root) %{_libdir}/qcg-comp/modules/qcg-comp-client.so

%files coordinator
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/qcg-coordinator
%attr(755,root,root) %{_sbindir}/qcg-coordinatord
%config(noreplace) %attr(640,root,root) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-coordinatord.xml
%config(noreplace) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-coordinator.xml
%attr(644,root,root) %{_libdir}/qcg-comp/modules/qcg-coordinator-service.so
%attr(644,root,root) %{_libdir}/qcg-comp/modules/qcg-coordinator-client.so
%attr(755,root,root) %verify(not md5 mtime size) %{_initrddir}/qcg-coordinatord
%dir %attr(750,root,root) %{_localstatedir}/log/qcg/qcg-coordinator
%dir %attr(750,root,root) %{_localstatedir}/run/qcg/qcg-coordinator


%files schemas
%defattr(644,root,root,755)
%{_datadir}/qcg-comp/interface
%{_datadir}/qcg-comp/xsd

%files java-sdk
%defattr(644,root,root,755)
/usr/share/qcg/qcg-comp-java-sdk/QCGComputingSDK.jar
/usr/share/qcg/qcg-comp-java-sdk/endorsed/jaxws-api-2.2.9.jar

%files offer
%defattr(644,root,root,755)
%{_qcgsysconfdir}/offer
%attr(755,root,root) %verify(not md5 mtime size) %{_bindir}/qcg-offer

%files slurm-redis-notifier
%attr(755,root,root) %{_bindir}/qcg-slurm-redis-notifier

%if %{system_name} == "centos7"
%attr(644,root,root) %{_unitdir}/qcg-slurm-redis-notifier.service
%else
%attr(755,root,root) %{_initrddir}/qcg-slurm-redis-notifier
%endif

%dir %{_qcgsysconfdir}
%config(noreplace) %verify(not md5 mtime size) %{_qcgsysconfdir}/qcg-slurm-redis-notifier.json


%changelog
* Thu Jan 26 2018 4.2
- Slurm redis notifier

* Thu Jun 19 2014 3.4.0-4
- Changed location of qcg-comp-java-sdk from /usr/share to the /usr/share/qcg 
- Added jaxws-api to be endorsed by qcg-comp-java-sdk

* Thu Oct 31 2013 3.1.0
- Added qcg-comp-java-sdk and qcg-comp-offer subpackages

* Wed Jul 17 2013  3.0.4-21
- Removed qcg-coordinator related routines from qcg-comp postun

* Tue Jul 16 2013 Bartosz Bosak <bbosak@man.poznan.pl> 3.0.4-20
- Fixed useradd and groupadd invokes for SL5
- Added changelog

